Index: squid/lib/dlmalloc.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/dlmalloc.c,v
retrieving revision 1.1.1.1.44.2
retrieving revision 1.1.1.1.44.2.2.1
diff -u -r1.1.1.1.44.2 -r1.1.1.1.44.2.2.1
--- squid/lib/dlmalloc.c	14 Jun 2001 21:34:24 -0000	1.1.1.1.44.2
+++ squid/lib/dlmalloc.c	27 Aug 2001 21:48:17 -0000	1.1.1.1.44.2.2.1
@@ -1,5 +1,5 @@
 /*
- * $Id: dlmalloc.c,v 1.1.1.1.44.2 2001/06/14 21:34:24 serassio Exp $
+ * $Id: dlmalloc.c,v 1.1.1.1.44.2.2.1 2001/08/27 21:48:17 tolsty Exp $
  */
 
 /* ---------- To make a malloc.h, start cutting here ------------ */
@@ -214,10 +214,10 @@
 
 
 */
-
 
 
 
+
 /* Preliminaries */
 
 #ifndef __STD_C
@@ -238,19 +238,20 @@
 #else
 #define Void_t      char
 #endif
-#endif /*Void_t*/
+#endif /*Void_t */
 
 #if __STD_C
-#include <stddef.h>   /* for size_t */
+#include <stddef.h>		/* for size_t */
 #else
 #include <sys/types.h>
 #endif
 
 #ifdef __cplusplus
-extern "C" {
+extern "C"
+{
 #endif
 
-#include <stdio.h>    /* needed for malloc_stats */
+#include <stdio.h>		/* needed for malloc_stats */
 
 
 /*
@@ -282,7 +283,7 @@
 
 */
 
-#if DEBUG 
+#if DEBUG
 #include <assert.h>
 #else
 #define assert(x) ((void)0)
@@ -338,7 +339,7 @@
 
 */
 
-#define HAVE_MEMCPY 
+#define HAVE_MEMCPY
 
 #ifndef USE_MEMCPY
 #ifdef HAVE_MEMCPY
@@ -348,14 +349,14 @@
 #endif
 #endif
 
-#if (__STD_C || defined(HAVE_MEMCPY)) 
+#if (__STD_C || defined(HAVE_MEMCPY))
 
 #if __STD_C
-void* memset(void*, int, size_t);
-void* memcpy(void*, const void*, size_t);
+    void *memset(void *, int, size_t);
+    void *memcpy(void *, const void *, size_t);
 #else
-Void_t* memset();
-Void_t* memcpy();
+    Void_t *memset();
+    Void_t *memcpy();
 #endif
 #endif
 
@@ -400,7 +401,7 @@
   } else memcpy(dest, src, mcsz);                                             \
 } while(0)
 
-#else /* !USE_MEMCPY */
+#else				/* !USE_MEMCPY */
 
 /* Use Duff's device for good zeroing/copying performance. */
 
@@ -476,7 +477,7 @@
 #define MAP_ANONYMOUS MAP_ANON
 #endif
 
-#endif /* HAVE_MMAP */
+#endif				/* HAVE_MMAP */
 
 /*
   Access to system page size. To the extent possible, this malloc
@@ -491,7 +492,7 @@
 #endif
 
 #ifndef malloc_getpagesize
-#  ifdef _SC_PAGESIZE         /* some SVR4 systems omit an underscore */
+#  ifdef _SC_PAGESIZE		/* some SVR4 systems omit an underscore */
 #    ifndef _SC_PAGE_SIZE
 #      define _SC_PAGE_SIZE _SC_PAGESIZE
 #    endif
@@ -500,7 +501,7 @@
 #    define malloc_getpagesize sysconf(_SC_PAGE_SIZE)
 #  else
 #    if defined(BSD) || defined(DGUX) || defined(HAVE_GETPAGESIZE)
-       extern size_t getpagesize();
+    extern size_t getpagesize();
 #      define malloc_getpagesize getpagesize()
 #    else
 #      include <sys/param.h>
@@ -513,19 +514,19 @@
 #          else
 #            define malloc_getpagesize (NBPG * CLSIZE)
 #          endif
-#        else 
+#        else
 #          ifdef NBPC
 #            define malloc_getpagesize NBPC
 #          else
 #            ifdef PAGESIZE
 #              define malloc_getpagesize PAGESIZE
 #            else
-#              define malloc_getpagesize (4096) /* just guess */
+#              define malloc_getpagesize (4096)	/* just guess */
 #            endif
 #          endif
-#        endif 
+#        endif
 #      endif
-#    endif 
+#    endif
 #  endif
 #endif
 
@@ -564,25 +565,26 @@
 
 /* SVID2/XPG mallinfo structure */
 
-struct mallinfo {
-  int arena;    /* total space allocated from system */
-  int ordblks;  /* number of non-inuse chunks */
-  int smblks;   /* unused -- always zero */
-  int hblks;    /* number of mmapped regions */
-  int hblkhd;   /* total space in mmapped regions */
-  int usmblks;  /* unused -- always zero */
-  int fsmblks;  /* unused -- always zero */
-  int uordblks; /* total allocated space */
-  int fordblks; /* total non-inuse space */
-  int keepcost; /* top-most, releasable (via malloc_trim) space */
-};	
+    struct mallinfo
+    {
+	int arena;		/* total space allocated from system */
+	int ordblks;		/* number of non-inuse chunks */
+	int smblks;		/* unused -- always zero */
+	int hblks;		/* number of mmapped regions */
+	int hblkhd;		/* total space in mmapped regions */
+	int usmblks;		/* unused -- always zero */
+	int fsmblks;		/* unused -- always zero */
+	int uordblks;		/* total allocated space */
+	int fordblks;		/* total non-inuse space */
+	int keepcost;		/* top-most, releasable (via malloc_trim) space */
+    };
 
 /* SVID2/XPG mallopt options */
 
-#define M_MXFAST  1    /* UNUSED in this malloc */
-#define M_NLBLKS  2    /* UNUSED in this malloc */
-#define M_GRAIN   3    /* UNUSED in this malloc */
-#define M_KEEP    4    /* UNUSED in this malloc */
+#define M_MXFAST  1		/* UNUSED in this malloc */
+#define M_NLBLKS  2		/* UNUSED in this malloc */
+#define M_GRAIN   3		/* UNUSED in this malloc */
+#define M_KEEP    4		/* UNUSED in this malloc */
 
 #endif
 
@@ -776,26 +778,26 @@
 
 #if __STD_C
 
-Void_t * __default_morecore_init (ptrdiff_t);
-Void_t *(*__morecore)(ptrdiff_t) = __default_morecore_init;
+    Void_t *__default_morecore_init(ptrdiff_t);
+    Void_t *(*__morecore) (ptrdiff_t) = __default_morecore_init;
 
 #else
 
-Void_t * __default_morecore_init ();
-Void_t *(*__morecore)() = __default_morecore_init;
+    Void_t *__default_morecore_init();
+    Void_t *(*__morecore) () = __default_morecore_init;
 
 #endif
 
 #define MORECORE (*__morecore)
 #define MORECORE_FAILURE 0
-#define MORECORE_CLEARS 1 
+#define MORECORE_CLEARS 1
 
-#else /* INTERNAL_LINUX_C_LIB */
+#else				/* INTERNAL_LINUX_C_LIB */
 
 #if __STD_C
-extern Void_t*     sbrk(ptrdiff_t);
+    extern Void_t *sbrk(ptrdiff_t);
 #else
-extern Void_t*     sbrk();
+    extern Void_t *sbrk();
 #endif
 
 #ifndef MORECORE
@@ -810,7 +812,7 @@
 #define MORECORE_CLEARS 1
 #endif
 
-#endif /* INTERNAL_LINUX_C_LIB */
+#endif				/* INTERNAL_LINUX_C_LIB */
 
 #if defined(INTERNAL_LINUX_C_LIB) && defined(__ELF__)
 
@@ -854,38 +856,38 @@
 
 #if __STD_C
 
-Void_t* mALLOc(size_t);
-void    fREe(Void_t*);
-Void_t* rEALLOc(Void_t*, size_t);
-Void_t* mEMALIGn(size_t, size_t);
-Void_t* vALLOc(size_t);
-Void_t* pvALLOc(size_t);
-Void_t* cALLOc(size_t, size_t);
-void    cfree(Void_t*);
-int     malloc_trim(size_t);
-size_t  malloc_usable_size(Void_t*);
-void    malloc_stats();
-int     mALLOPt(int, int);
-struct mallinfo mALLINFo(void);
-#else
-Void_t* mALLOc();
-void    fREe();
-Void_t* rEALLOc();
-Void_t* mEMALIGn();
-Void_t* vALLOc();
-Void_t* pvALLOc();
-Void_t* cALLOc();
-void    cfree();
-int     malloc_trim();
-size_t  malloc_usable_size();
-void    malloc_stats();
-int     mALLOPt();
-struct mallinfo mALLINFo();
+    Void_t *mALLOc(size_t);
+    void fREe(Void_t *);
+    Void_t *rEALLOc(Void_t *, size_t);
+    Void_t *mEMALIGn(size_t, size_t);
+    Void_t *vALLOc(size_t);
+    Void_t *pvALLOc(size_t);
+    Void_t *cALLOc(size_t, size_t);
+    void cfree(Void_t *);
+    int malloc_trim(size_t);
+    size_t malloc_usable_size(Void_t *);
+    void malloc_stats();
+    int mALLOPt(int, int);
+    struct mallinfo mALLINFo(void);
+#else
+    Void_t *mALLOc();
+    void fREe();
+    Void_t *rEALLOc();
+    Void_t *mEMALIGn();
+    Void_t *vALLOc();
+    Void_t *pvALLOc();
+    Void_t *cALLOc();
+    void cfree();
+    int malloc_trim();
+    size_t malloc_usable_size();
+    void malloc_stats();
+    int mALLOPt();
+    struct mallinfo mALLINFo();
 #endif
 
 
 #ifdef __cplusplus
-};  /* end of extern "C" */
+};				/* end of extern "C" */
 #endif
 
 /* ---------- To make a malloc.h, end cutting here ------------ */
@@ -900,164 +902,147 @@
 #ifdef WIN32
 
 #define AlignPage(add) (((add) + (malloc_getpagesize-1)) &
-~(malloc_getpagesize-1))
+~(malloc_getpagesize - 1))
 
-/* resrve 64MB to insure large contiguous space */ 
+/* resrve 64MB to insure large contiguous space */
 #define RESERVED_SIZE (1024*1024*64)
 #define NEXT_SIZE (2048*1024)
 #define TOP_MEMORY ((unsigned long)2*1024*1024*1024)
+     struct GmListElement;
+     typedef struct GmListElement GmListElement;
 
-struct GmListElement;
-typedef struct GmListElement GmListElement;
+     struct GmListElement
+     {
+	 GmListElement *next;
+	 void *base;
+     };
 
-struct GmListElement 
-{
-	GmListElement* next;
-	void* base;
-};
-
-static GmListElement* head = 0;
+static GmListElement *head = 0;
 static unsigned int gNextAddress = 0;
 static unsigned int gAddressBase = 0;
 static unsigned int gAllocatedSize = 0;
 
-static
-GmListElement* makeGmListElement (void* bas)
+static GmListElement *makeGmListElement(void *bas)
 {
-	GmListElement* this;
-	this = (GmListElement*)(void*)LocalAlloc (0, sizeof (GmListElement));
-	ASSERT (this);
-	if (this)
-	{
-		this->base = bas;
-		this->next = head;
-		head = this;
-	}
-	return this;
+    GmListElement *this;
+                  this = (GmListElement *) (void *) LocalAlloc(0, sizeof(GmListElement));
+                  ASSERT(this);
+    if            (this)
+    {
+	this->base = bas;
+	this->next = head;
+	head = this;
+    }
+    return this;
 }
 
-void gcleanup ()
+void gcleanup()
 {
-	BOOL rval;
-	ASSERT ( (head == NULL) || (head->base == (void*)gAddressBase));
-	if (gAddressBase && (gNextAddress - gAddressBase))
-	{
-		rval = VirtualFree ((void*)gAddressBase, 
-							gNextAddress - gAddressBase, 
-							MEM_DECOMMIT);
-        ASSERT (rval);
-	}
-	while (head)
-	{
-		GmListElement* next = head->next;
-		rval = VirtualFree (head->base, 0, MEM_RELEASE);
-		ASSERT (rval);
-		LocalFree (head);
-		head = next;
-	}
+    BOOL rval;
+    ASSERT((head == NULL) || (head->base == (void *) gAddressBase));
+    if (gAddressBase && (gNextAddress - gAddressBase)) {
+	rval = VirtualFree((void *) gAddressBase,
+	    gNextAddress - gAddressBase, MEM_DECOMMIT);
+	ASSERT(rval);
+    }
+    while (head) {
+	GmListElement *next = head->next;
+	rval = VirtualFree(head->base, 0, MEM_RELEASE);
+	ASSERT(rval);
+	LocalFree(head);
+	head = next;
+    }
 }
-		
-static
-void* findRegion (void* start_address, unsigned long size)
+
+static void *findRegion(void *start_address, unsigned long size)
 {
-	MEMORY_BASIC_INFORMATION info;
-	while ((unsigned long)start_address < TOP_MEMORY)
-	{
-		VirtualQuery (start_address, &info, sizeof (info));
-		if (info.State != MEM_FREE)
-			start_address = (char*)info.BaseAddress + info.RegionSize;
-		else if (info.RegionSize >= size)
-			return start_address;
-		else
-			start_address = (char*)info.BaseAddress + info.RegionSize; 
-	}
-	return NULL;
-	
+    MEMORY_BASIC_INFORMATION info;
+    while                    ((unsigned long) start_address < TOP_MEMORY)
+    {
+	VirtualQuery(start_address, &info, sizeof(info));
+	if (info.State != MEM_FREE)
+	    start_address = (char *) info.BaseAddress + info.RegionSize;
+	else if (info.RegionSize >= size)
+	    return start_address;
+	else
+	    start_address = (char *) info.BaseAddress + info.RegionSize;
+    }
+    return NULL;
+
 }
 
 
-void* wsbrk (long size)
+void *wsbrk(long size)
 {
-	void* tmp;
-	if (size > 0)
+    void *tmp;
+    if   (size > 0)
+    {
+	if (gAddressBase == 0) {
+	    gAllocatedSize = max(RESERVED_SIZE, AlignPage(size));
+	    gNextAddress = gAddressBase =
+		(unsigned int) VirtualAlloc(NULL, gAllocatedSize,
+		MEM_RESERVE, PAGE_NOACCESS);
+	} else if (AlignPage(gNextAddress + size) > (gAddressBase +
+		gAllocatedSize))
 	{
-		if (gAddressBase == 0)
-		{
-			gAllocatedSize = max (RESERVED_SIZE, AlignPage (size));
-			gNextAddress = gAddressBase = 
-				(unsigned int)VirtualAlloc (NULL, gAllocatedSize, 
-											MEM_RESERVE, PAGE_NOACCESS);
-		} else if (AlignPage (gNextAddress + size) > (gAddressBase +
-gAllocatedSize))
-		{
-			long new_size = max (NEXT_SIZE, AlignPage (size));
-			void* new_address = (void*)(gAddressBase+gAllocatedSize);
-			do 
-			{
-				new_address = findRegion (new_address, new_size);
-				
-				if (new_address == 0)
-					return (void*)-1;
-
-				gAddressBase = gNextAddress =
-					(unsigned int)VirtualAlloc (new_address, new_size,
-												MEM_RESERVE, PAGE_NOACCESS);
-				// repeat in case of race condition
-				// The region that we found has been snagged 
-				// by another thread
-			}
-			while (gAddressBase == 0);
+	    long new_size = max(NEXT_SIZE, AlignPage(size));
+	    void *new_address = (void *) (gAddressBase + gAllocatedSize);
+	    do {
+		new_address = findRegion(new_address, new_size);
+
+		if (new_address == 0)
+		    return (void *) -1;
+
+		gAddressBase = gNextAddress =
+		    (unsigned int) VirtualAlloc(new_address, new_size,
+		    MEM_RESERVE, PAGE_NOACCESS);
+		// repeat in case of race condition
+		// The region that we found has been snagged 
+		// by another thread
+	    }
+	    while (gAddressBase == 0);
 
-			ASSERT (new_address == (void*)gAddressBase);
+	    ASSERT(new_address == (void *) gAddressBase);
 
-			gAllocatedSize = new_size;
+	    gAllocatedSize = new_size;
 
-			if (!makeGmListElement ((void*)gAddressBase))
-				return (void*)-1;
-		}
-		if ((size + gNextAddress) > AlignPage (gNextAddress))
-		{
-			void* res;
-			res = VirtualAlloc ((void*)AlignPage (gNextAddress),
-								(size + gNextAddress - 
-								 AlignPage (gNextAddress)), 
-								MEM_COMMIT, PAGE_READWRITE);
-			if (res == 0)
-				return (void*)-1;
-		}
-		tmp = (void*)gNextAddress;
-		gNextAddress = (unsigned int)tmp + size;
-		return tmp;
+	    if (!makeGmListElement((void *) gAddressBase))
+		return (void *) -1;
 	}
-	else if (size < 0)
-	{
-		unsigned int alignedGoal = AlignPage (gNextAddress + size);
-		/* Trim by releasing the virtual memory */
-		if (alignedGoal >= gAddressBase)
-		{
-			VirtualFree ((void*)alignedGoal, gNextAddress - alignedGoal,  
-						 MEM_DECOMMIT);
-			gNextAddress = gNextAddress + size;
-			return (void*)gNextAddress;
-		}
-		else 
-		{
-			VirtualFree ((void*)gAddressBase, gNextAddress - gAddressBase,
-						 MEM_DECOMMIT);
-			gNextAddress = gAddressBase;
-			return (void*)-1;
-		}
+	if ((size + gNextAddress) > AlignPage(gNextAddress)) {
+	    void *res;
+	    res = VirtualAlloc((void *) AlignPage(gNextAddress),
+		(size + gNextAddress -
+		    AlignPage(gNextAddress)), MEM_COMMIT, PAGE_READWRITE);
+	    if (res == 0)
+		return (void *) -1;
 	}
-	else
-	{
-		return (void*)gNextAddress;
+	tmp = (void *) gNextAddress;
+	gNextAddress = (unsigned int) tmp + size;
+	return tmp;
+    } else if (size < 0) {
+	unsigned int alignedGoal = AlignPage(gNextAddress + size);
+	/* Trim by releasing the virtual memory */
+	if (alignedGoal >= gAddressBase) {
+	    VirtualFree((void *) alignedGoal, gNextAddress - alignedGoal,
+		MEM_DECOMMIT);
+	    gNextAddress = gNextAddress + size;
+	    return (void *) gNextAddress;
+	} else {
+	    VirtualFree((void *) gAddressBase, gNextAddress - gAddressBase,
+		MEM_DECOMMIT);
+	    gNextAddress = gAddressBase;
+	    return (void *) -1;
 	}
+    } else {
+	return (void *) gNextAddress;
+    }
 }
 
 #endif
-
 
 
+
 /*
   Type declarations
 */
@@ -1065,13 +1050,13 @@
 
 struct malloc_chunk
 {
-  INTERNAL_SIZE_T prev_size; /* Size of previous chunk (if free). */
-  INTERNAL_SIZE_T size;      /* Size in bytes, including overhead. */
-  struct malloc_chunk* fd;   /* double links -- used only if free. */
-  struct malloc_chunk* bk;
+    INTERNAL_SIZE_T prev_size;	/* Size of previous chunk (if free). */
+    INTERNAL_SIZE_T size;	/* Size in bytes, including overhead. */
+    struct malloc_chunk *fd;	/* double links -- used only if free. */
+    struct malloc_chunk *bk;
 };
 
-typedef struct malloc_chunk* mchunkptr;
+typedef struct malloc_chunk *mchunkptr;
 
 /*
 
@@ -1196,10 +1181,10 @@
        serviced via calls to mmap, and then later released via munmap.
 
 */
+
 
 
 
-
 
 
 /*  sizes, alignments */
@@ -1224,9 +1209,9 @@
 /* Check if m has acceptable alignment */
 
 #define aligned_OK(m)    (((unsigned long)((m)) & (MALLOC_ALIGN_MASK)) == 0)
+
 
 
-
 
 /* 
   Physical chunk operations  
@@ -1235,7 +1220,7 @@
 
 /* size field is or'ed with PREV_INUSE when previous adjacent chunk in use */
 
-#define PREV_INUSE 0x1 
+#define PREV_INUSE 0x1
 
 /* size field is or'ed with IS_MMAPPED if the chunk was obtained with mmap() */
 
@@ -1259,9 +1244,9 @@
 /* Treat space at ptr + offset as a chunk */
 
 #define chunk_at_offset(p, s)  ((mchunkptr)(((char*)(p)) + (s)))
+
 
 
-
 
 /* 
   Dealing with use bits 
@@ -1298,9 +1283,9 @@
 
 #define clear_inuse_bit_at_offset(p, s)\
  (((mchunkptr)(((char*)(p)) + (s)))->size &= ~(PREV_INUSE))
+
 
 
-
 
 /* 
   Dealing with size fields 
@@ -1321,9 +1306,9 @@
 /* Set size at footer (only when chunk is not in use) */
 
 #define set_foot(p, s)   (((mchunkptr)((char*)(p) + (s)))->prev_size = (s))
+
 
 
-
 
 
 /*
@@ -1360,9 +1345,9 @@
 
 */
 
-#define NAV             128   /* number of bins */
+#define NAV             128	/* number of bins */
 
-typedef struct malloc_chunk* mbinptr;
+typedef struct malloc_chunk *mbinptr;
 
 /* access macros */
 
@@ -1376,8 +1361,8 @@
    indexing, maintain locality, and avoid some initialization tests.
 */
 
-#define top            (bin_at(0)->fd)   /* The topmost chunk */
-#define last_remainder (bin_at(1))       /* remainder from last split */
+#define top            (bin_at(0)->fd)	/* The topmost chunk */
+#define last_remainder (bin_at(1))	/* remainder from last split */
 
 
 /*
@@ -1393,28 +1378,30 @@
 
 #define IAV(i)  bin_at(i), bin_at(i)
 
-static mbinptr av_[NAV * 2 + 2] = {
- 0, 0,
- IAV(0),   IAV(1),   IAV(2),   IAV(3),   IAV(4),   IAV(5),   IAV(6),   IAV(7),
- IAV(8),   IAV(9),   IAV(10),  IAV(11),  IAV(12),  IAV(13),  IAV(14),  IAV(15),
- IAV(16),  IAV(17),  IAV(18),  IAV(19),  IAV(20),  IAV(21),  IAV(22),  IAV(23),
- IAV(24),  IAV(25),  IAV(26),  IAV(27),  IAV(28),  IAV(29),  IAV(30),  IAV(31),
- IAV(32),  IAV(33),  IAV(34),  IAV(35),  IAV(36),  IAV(37),  IAV(38),  IAV(39),
- IAV(40),  IAV(41),  IAV(42),  IAV(43),  IAV(44),  IAV(45),  IAV(46),  IAV(47),
- IAV(48),  IAV(49),  IAV(50),  IAV(51),  IAV(52),  IAV(53),  IAV(54),  IAV(55),
- IAV(56),  IAV(57),  IAV(58),  IAV(59),  IAV(60),  IAV(61),  IAV(62),  IAV(63),
- IAV(64),  IAV(65),  IAV(66),  IAV(67),  IAV(68),  IAV(69),  IAV(70),  IAV(71),
- IAV(72),  IAV(73),  IAV(74),  IAV(75),  IAV(76),  IAV(77),  IAV(78),  IAV(79),
- IAV(80),  IAV(81),  IAV(82),  IAV(83),  IAV(84),  IAV(85),  IAV(86),  IAV(87),
- IAV(88),  IAV(89),  IAV(90),  IAV(91),  IAV(92),  IAV(93),  IAV(94),  IAV(95),
- IAV(96),  IAV(97),  IAV(98),  IAV(99),  IAV(100), IAV(101), IAV(102), IAV(103),
- IAV(104), IAV(105), IAV(106), IAV(107), IAV(108), IAV(109), IAV(110), IAV(111),
- IAV(112), IAV(113), IAV(114), IAV(115), IAV(116), IAV(117), IAV(118), IAV(119),
- IAV(120), IAV(121), IAV(122), IAV(123), IAV(124), IAV(125), IAV(126), IAV(127)
+static mbinptr av_[NAV * 2 + 2] =
+{
+    0, 0,
+	IAV(0), IAV(1), IAV(2), IAV(3), IAV(4), IAV(5), IAV(6), IAV(7),
+	IAV(8), IAV(9), IAV(10), IAV(11), IAV(12), IAV(13), IAV(14), IAV(15),
+	IAV(16), IAV(17), IAV(18), IAV(19), IAV(20), IAV(21), IAV(22), IAV(23),
+	IAV(24), IAV(25), IAV(26), IAV(27), IAV(28), IAV(29), IAV(30), IAV(31),
+	IAV(32), IAV(33), IAV(34), IAV(35), IAV(36), IAV(37), IAV(38), IAV(39),
+	IAV(40), IAV(41), IAV(42), IAV(43), IAV(44), IAV(45), IAV(46), IAV(47),
+	IAV(48), IAV(49), IAV(50), IAV(51), IAV(52), IAV(53), IAV(54), IAV(55),
+	IAV(56), IAV(57), IAV(58), IAV(59), IAV(60), IAV(61), IAV(62), IAV(63),
+	IAV(64), IAV(65), IAV(66), IAV(67), IAV(68), IAV(69), IAV(70), IAV(71),
+	IAV(72), IAV(73), IAV(74), IAV(75), IAV(76), IAV(77), IAV(78), IAV(79),
+	IAV(80), IAV(81), IAV(82), IAV(83), IAV(84), IAV(85), IAV(86), IAV(87),
+	IAV(88), IAV(89), IAV(90), IAV(91), IAV(92), IAV(93), IAV(94), IAV(95),
+	IAV(96), IAV(97), IAV(98), IAV(99), IAV(100), IAV(101), IAV(102),
+	IAV(103), IAV(104), IAV(105), IAV(106), IAV(107), IAV(108), IAV(109),
+	IAV(110), IAV(111), IAV(112), IAV(113), IAV(114), IAV(115), IAV(116),
+	IAV(117), IAV(118), IAV(119), IAV(120), IAV(121), IAV(122), IAV(123),
+	IAV(124), IAV(125), IAV(126), IAV(127)
 };
-
 
 
+
 /* field-extraction macros */
 
 #define first(b) ((b)->fd)
@@ -1431,7 +1418,7 @@
  ((((unsigned long)(sz)) >> 9) <=   84) ? 110 + (((unsigned long)(sz)) >> 12): \
  ((((unsigned long)(sz)) >> 9) <=  340) ? 119 + (((unsigned long)(sz)) >> 15): \
  ((((unsigned long)(sz)) >> 9) <= 1364) ? 124 + (((unsigned long)(sz)) >> 18): \
-                                          126)                     
+                                          126)
 /* 
   bins for chunks < 512 are all spaced 8 bytes apart, and hold
   identically sized chunks. This is exploited in malloc.
@@ -1448,9 +1435,9 @@
 */
 
 #define is_small_request(nb) (nb < MAX_SMALLBIN_SIZE - SMALLBIN_WIDTH)
-
 
 
+
 /*
     To help compensate for the large number of bins, a one-level index
     structure is used for bin-by-bin searching.  `binblocks' is a
@@ -1461,40 +1448,42 @@
     when all are noticed to be empty during traversal in malloc.
 */
 
-#define BINBLOCKWIDTH     4   /* bins per block */
+#define BINBLOCKWIDTH     4	/* bins per block */
 
-#define binblocks      (bin_at(0)->size) /* bitvector of nonempty blocks */
+#define binblocks      (bin_at(0)->size)	/* bitvector of nonempty blocks */
 
 /* bin<->block macros */
 
 #define idx2binblock(ix)    ((unsigned)1 << (ix / BINBLOCKWIDTH))
 #define mark_binblock(ii)   (binblocks |= idx2binblock(ii))
 #define clear_binblock(ii)  (binblocks &= ~(idx2binblock(ii)))
+
 
 
-
 
 
 /*  Other static bookkeeping data */
 
 /* variables holding tunable values */
 
-static unsigned long trim_threshold   = DEFAULT_TRIM_THRESHOLD;
-static unsigned long top_pad          = DEFAULT_TOP_PAD;
-static unsigned int  n_mmaps_max      = DEFAULT_MMAP_MAX;
-static unsigned long mmap_threshold   = DEFAULT_MMAP_THRESHOLD;
+static unsigned long trim_threshold = DEFAULT_TRIM_THRESHOLD;
+static unsigned long top_pad = DEFAULT_TOP_PAD;
+static unsigned int n_mmaps_max = DEFAULT_MMAP_MAX;
+static unsigned long mmap_threshold = DEFAULT_MMAP_THRESHOLD;
 
 /* The first value returned from sbrk */
-static char* sbrk_base = (char*)(-1);
+static char *sbrk_base = (char *) (-1);
 
 /* The maximum memory obtained from system via sbrk */
-static unsigned long max_sbrked_mem = 0; 
+static unsigned long max_sbrked_mem = 0;
 
 /* The maximum via either sbrk or mmap */
-static unsigned long max_total_mem = 0; 
+static unsigned long max_total_mem = 0;
 
 /* internal working copy of mallinfo */
-static struct mallinfo current_mallinfo = {  0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
+static struct mallinfo current_mallinfo =
+{
+0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
 
 /* The total memory obtained from system via sbrk */
 #define sbrked_mem  (current_mallinfo.arena)
@@ -1505,9 +1494,9 @@
 static unsigned int max_n_mmaps = 0;
 static unsigned long mmapped_mem = 0;
 static unsigned long max_mmapped_mem = 0;
-
 
 
+
 /* 
   Debugging support 
 */
@@ -1524,114 +1513,114 @@
 */
 
 #if __STD_C
-static void do_check_chunk(mchunkptr p) 
+static void do_check_chunk(mchunkptr p)
 #else
-static void do_check_chunk(p) mchunkptr p;
+static void do_check_chunk(p)
+     mchunkptr p;
 #endif
-{ 
-  INTERNAL_SIZE_T sz = p->size & ~PREV_INUSE;
+{
+    INTERNAL_SIZE_T sz = p->size & ~PREV_INUSE;
 
-  /* No checkable chunk is mmapped */
-  assert(!chunk_is_mmapped(p));
+    /* No checkable chunk is mmapped */
+    assert(!chunk_is_mmapped(p));
 
-  /* Check for legal address ... */
-  assert((char*)p >= sbrk_base);
-  if (p != top) 
-    assert((char*)p + sz <= (char*)top);
-  else
-    assert((char*)p + sz <= sbrk_base + sbrked_mem);
+    /* Check for legal address ... */
+    assert((char *) p >= sbrk_base);
+    if (p != top)
+	assert((char *) p + sz <= (char *) top);
+    else
+	assert((char *) p + sz <= sbrk_base + sbrked_mem);
 
 }
 
 
 #if __STD_C
-static void do_check_free_chunk(mchunkptr p) 
+static void do_check_free_chunk(mchunkptr p)
 #else
-static void do_check_free_chunk(p) mchunkptr p;
+static void do_check_free_chunk(p)
+     mchunkptr p;
 #endif
-{ 
-  INTERNAL_SIZE_T sz = p->size & ~PREV_INUSE;
-  mchunkptr next = chunk_at_offset(p, sz);
+{
+    INTERNAL_SIZE_T sz = p->size & ~PREV_INUSE;
+    mchunkptr next = chunk_at_offset(p, sz);
 
-  do_check_chunk(p);
+    do_check_chunk(p);
 
-  /* Check whether it claims to be free ... */
-  assert(!inuse(p));
+    /* Check whether it claims to be free ... */
+    assert(!inuse(p));
 
-  /* Unless a special marker, must have OK fields */
-  if ((long)sz >= (long)MINSIZE)
-  {
-    assert((sz & MALLOC_ALIGN_MASK) == 0);
-    assert(aligned_OK(chunk2mem(p)));
-    /* ... matching footer field */
-    assert(next->prev_size == sz);
-    /* ... and is fully consolidated */
-    assert(prev_inuse(p));
-    assert (next == top || inuse(next));
-    
-    /* ... and has minimally sane links */
-    assert(p->fd->bk == p);
-    assert(p->bk->fd == p);
-  }
-  else /* markers are always of size SIZE_SZ */
-    assert(sz == SIZE_SZ); 
+    /* Unless a special marker, must have OK fields */
+    if ((long) sz >= (long) MINSIZE) {
+	assert((sz & MALLOC_ALIGN_MASK) == 0);
+	assert(aligned_OK(chunk2mem(p)));
+	/* ... matching footer field */
+	assert(next->prev_size == sz);
+	/* ... and is fully consolidated */
+	assert(prev_inuse(p));
+	assert(next == top || inuse(next));
+
+	/* ... and has minimally sane links */
+	assert(p->fd->bk == p);
+	assert(p->bk->fd == p);
+    } else			/* markers are always of size SIZE_SZ */
+	assert(sz == SIZE_SZ);
 }
 
 #if __STD_C
-static void do_check_inuse_chunk(mchunkptr p) 
+static void do_check_inuse_chunk(mchunkptr p)
 #else
-static void do_check_inuse_chunk(p) mchunkptr p;
+static void do_check_inuse_chunk(p)
+     mchunkptr p;
 #endif
-{ 
-  mchunkptr next = next_chunk(p);
-  do_check_chunk(p);
+{
+    mchunkptr next = next_chunk(p);
+    do_check_chunk(p);
 
-  /* Check whether it claims to be in use ... */
-  assert(inuse(p));
+    /* Check whether it claims to be in use ... */
+    assert(inuse(p));
 
-  /* ... and is surrounded by OK chunks.
-    Since more things can be checked with free chunks than inuse ones,
-    if an inuse chunk borders them and debug is on, it's worth doing them.
-  */
-  if (!prev_inuse(p)) 
-  {
-    mchunkptr prv = prev_chunk(p);
-    assert(next_chunk(prv) == p);
-    do_check_free_chunk(prv);
-  }
-  if (next == top)
-  {
-    assert(prev_inuse(next));
-    assert(chunksize(next) >= MINSIZE);
-  }
-  else if (!inuse(next))
-    do_check_free_chunk(next);
+    /* ... and is surrounded by OK chunks.
+     * Since more things can be checked with free chunks than inuse ones,
+     * if an inuse chunk borders them and debug is on, it's worth doing them.
+     */
+    if (!prev_inuse(p)) {
+	mchunkptr prv = prev_chunk(p);
+	assert(next_chunk(prv) == p);
+	do_check_free_chunk(prv);
+    }
+    if (next == top) {
+	assert(prev_inuse(next));
+	assert(chunksize(next) >= MINSIZE);
+    } else if (!inuse(next))
+	do_check_free_chunk(next);
 
 }
 
 #if __STD_C
-static void do_check_malloced_chunk(mchunkptr p, INTERNAL_SIZE_T s) 
+static void do_check_malloced_chunk(mchunkptr p, INTERNAL_SIZE_T s)
 #else
-static void do_check_malloced_chunk(p, s) mchunkptr p; INTERNAL_SIZE_T s;
+static void do_check_malloced_chunk(p, s)
+     mchunkptr p;
+     INTERNAL_SIZE_T s;
 #endif
 {
-  INTERNAL_SIZE_T sz = p->size & ~PREV_INUSE;
-  long room = sz - s;
+    INTERNAL_SIZE_T sz = p->size & ~PREV_INUSE;
+    long room = sz - s;
 
-  do_check_inuse_chunk(p);
+    do_check_inuse_chunk(p);
 
-  /* Legal size ... */
-  assert((long)sz >= (long)MINSIZE);
-  assert((sz & MALLOC_ALIGN_MASK) == 0);
-  assert(room >= 0);
-  assert(room < (long)MINSIZE);
+    /* Legal size ... */
+    assert((long) sz >= (long) MINSIZE);
+    assert((sz & MALLOC_ALIGN_MASK) == 0);
+    assert(room >= 0);
+    assert(room < (long) MINSIZE);
 
-  /* ... and alignment */
-  assert(aligned_OK(chunk2mem(p)));
+    /* ... and alignment */
+    assert(aligned_OK(chunk2mem(p)));
 
 
-  /* ... and was allocated at front of an available chunk */
-  assert(prev_inuse(p));
+    /* ... and was allocated at front of an available chunk */
+    assert(prev_inuse(p));
 
 }
 
@@ -1641,14 +1630,14 @@
 #define check_chunk(P) do_check_chunk(P)
 #define check_malloced_chunk(P,N) do_check_malloced_chunk(P,N)
 #else
-#define check_free_chunk(P) 
+#define check_free_chunk(P)
 #define check_inuse_chunk(P)
 #define check_chunk(P)
 #define check_malloced_chunk(P,N)
 #endif
-
 
 
+
 /* 
   Macro-based internal utilities
 */
@@ -1717,10 +1706,10 @@
 
 #define clear_last_remainder \
   (last_remainder->fd = last_remainder->bk = last_remainder)
+
 
 
 
-
 
 
 /* Routines dealing with mmap(). */
